function getDate() {
  var today = new Date();
  var dd = today.getDate();
  var mm = today.getMonth() + 1; //January is 0!
  var yyyy = today.getFullYear();

  if (dd < 10) {
    dd = '0' + dd;
  }

  if (mm < 10) {
    mm = '0' + mm;
  }

   return dd + '.' + mm + '.' + yyyy;
}

define(['ojs/ojcore', 'knockout', 'jquery', 'appController', 'ojs/ojmodule-element-utils', 'ojs/ojbutton', 'ojs/ojknockout', 'ojs/ojinputtext', 'ojs/ojlabel'],
 function(oj, ko, $, app, moduleUtils) {

   var router = oj.Router.rootInstance;

    function EditPasswordViewModel(viewParams) {
      var self = this;
      var rootViewModel;

      oj.Router.sync();

      // Header Config
      self.headerConfig = ko.observable({'view':[], 'viewModel':null});
      moduleUtils.createView({'viewPath':'views/header.html'}).then(function(view) {
        self.headerConfig({'view':view, 'viewModel':new app.getHeaderModel()})
      })

      // Below are a set of the ViewModel methods invoked by the oj-module component.
      // Please reference the oj-module jsDoc for additional information.

      /**
       * Optional ViewModel method invoked after the View is inserted into the
       * document DOM.  The application can put logic that requires the DOM being
       * attached here.
       * This method might be called multiple times - after the View is created
       * and inserted into the DOM and after the View is reconnected
       * after being disconnected.
       */
      self.connected = function() {
        rootViewModel = ko.dataFor(document.getElementById('globalBody'));
        //If userId is undefined, go back to login-page:
        if (rootViewModel.userId() == undefined) {
          oj.Router.rootInstance.go('login');
          return
        }

        // Implement if needed
      };

      /**
       * Optional ViewModel method invoked after the View is disconnected from the DOM.
       */
      self.disconnected = function() {
        // Implement if needed
      };

      /**
       * Optional ViewModel method invoked after transition to the new View is complete.
       * That includes any possible animation between the old and the new View.
       */
      self.transitionCompleted = function() {
        // Implement if needed
      };

      // Function for saving the new information back to the database
      self.saveData = function() {
        var newP = document.getElementById("newPassword").value;
        var newPC = document.getElementById("newPasswordConfirm").value;

        var data = null;
        var body = {
          bruker_id: "NTNU",
          bruker_passord: document.getElementById("oldPassword").value,
          bruker_nytt_passord: document.getElementById("newPassword").value,
          dato: getDate()
        }

        if (newP == newPC) {
          $.ajax({
            type: "POST",
            url: rootViewModel.baseUrl() + "bruker/endre",
            // The key needs to match your method's input parameter (case-sensitive).
            data: JSON.stringify(body),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(data){
              rootViewModel.userId(data.userId);
              rootViewModel.showSaveSuccess("Nytt passord er nå lagret");
              router.go("frontpage");
              console.log(data.userId);
            },
            error: function(errMsg) {
                document.getElementById("errorText").innerHTML = "Feil passord";
            }
          });
        }
        else {
          document.getElementById("errorText").innerHTML = "Passordet stemmer ikke";
        }

      };
    }

    /*
     * Returns a constructor for the ViewModel so that the ViewModel is constructed
     * each time the view is displayed.  Return an instance of the ViewModel if
     * only one instance of the ViewModel is needed.
     */
    return new EditPasswordViewModel();
  }
);
