function getDate() {
  var today = new Date();
  var dd = today.getDate();
  var mm = today.getMonth() + 1; //January is 0!
  var yyyy = today.getFullYear();

  if (dd < 10) {
    dd = '0' + dd;
  }

  if (mm < 10) {
    mm = '0' + mm;
  }

   return dd + '.' + mm + '.' + yyyy;
}

define(['ojs/ojcore', 'knockout', 'jquery', 'appController',
'ojs/ojmodule-element-utils', 'ojs/ojknockout', 'ojs/ojbutton', 'ojs/ojinputtext',
'ojs/ojlabel', 'ojs/ojmodel', 'ojs/ojinputnumber'],
 function(oj, ko, $, app, moduleUtils) {

   var router = oj.Router.rootInstance;

    function LoginViewModel() {
      var self = this;

      var rootViewModel = ko.dataFor(document.getElementById('globalBody'));
      var userId = rootViewModel.userId();

      this.userId = ko.observable("");
      this.userPassword = ko.observable("");

      // Header Config
      self.headerConfig = ko.observable({'view':[], 'viewModel':null});
      moduleUtils.createView({'viewPath':'views/header.html'}).then(function(view) {
        self.headerConfig({'view':view, 'viewModel':new app.getHeaderModel()})
      })

      self.clickLogin = function() {
        var data = null;
        var body = {
          bruker_id: self.userId(),
          bruker_passord: self.userPassword(),
          dato: getDate()
        }

        self.userPassword(""); // Removes password from observable

        $.ajax({
          type: "POST",
          url: rootViewModel.baseUrl() + "bruker/login",
          // The key needs to match your method's input parameter (case-sensitive).
          data: JSON.stringify(body),
          contentType: "application/json; charset=utf-8",
          dataType: "json",
          success: function(data){
            rootViewModel.userId(data.userId);
            rootViewModel.userRole(data.brukerRolle);
            console.log(data.brukerRolle);
            // If the user's role is not Admin(3) or Coordinator(4)
            if (data.brukerRolle != 3 && data.brukerRolle != 4) {
              // User is directed to normal front page
              router.go("/frontpage");
            }
            else {
              // User is directed to admin front page
              router.go("/adminFrontpage");
            }
          },
          error: function(errMsg) {
            writeErrorMessage();
          }
        });
      };

      self.clickForgot = function() {
        router.go("/forgotPassword");
      }
    }

    function writeErrorMessage() {
      document.getElementById("errorText").innerHTML = "Feil bruker ID og/eller passord";
    }

    return new LoginViewModel();
  }
);
