<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET,PUT,POST,DELETE");
header("Access-Control-Allow-Headers: Content-Type, Authorization");
header('Content-Type: application/json');
$module = htmlspecialchars($_GET['module']);
$param1 = htmlspecialchars($_GET['param1']);
$param2 = htmlspecialchars($_GET['param2']);
$param3 = htmlspecialchars($_GET['param3']);
$param4 = htmlspecialchars($_GET['param4']);
$param5 = htmlspecialchars($_GET['param5']);

//echo $module . "/" . $param1 . "/" . $param2 . "/" . $param3 . "/" . $param4 . "/" . $param5;

function voluntary($userId, $param2, $param3) {
    if ($param2 == "interesser" && $param3 == "finn_nye") {         // If getting or setting a new interest.
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            # Get JSON as a string
            $json_str = file_get_contents('php://input');

            # Get as an object
            $json_obj = json_decode($json_str, true);

            file_put_contents(htmlspecialchars($json_obj["bruker_id"]) . "-interests.txt", htmlspecialchars($json_obj["tjeneste_id"])."\n", FILE_APPEND);
        }
        else {
            $results = getInterest(-1);
            echo json_encode(createCollection($results));
        }
    }
    else if ($param2 == "interesser" && $param3 != "finn_nye") {            // If getting current interests.
        if (file_exists($userId . "-interests.txt")) {
            $result = array();
            $fn = fopen($userId . "-interests.txt","r");
      
            while(! feof($fn))  {
                $id = fgets($fn);
                array_push($result, getInterest($id));
            }
    
            fclose($fn);
            echo json_encode(createCollection($result));
        }
        else {
            err();
        }
    }
    else if ($param2 == "idkort") {
        echo getFile("voluntary-" . $userId . "-idcard.json");
    }
    else if ($param2 == "avtaler" && $param3 == "eldre") {
        $files = glob('voluntary-appointments-'.$userId.'-*');
        $result = array();

        // List all agreements for that user in array:
        for ($i = 0; $i < sizeof($files); $i++) {
            array_push($result, json_decode(getFile($files[$i]), true));
        }

        echo json_encode(createCollection($result));
    }
    else {
        err();
    }
}

function services($param1, $param2, $param3, $param4, $param5) {
    if ($param1 == "oppdrag") {
        if ($param2 == "interesser") {
            echo getFile("services-test-interests.json");
        }
        else if ($param2 == "alle") {
            echo getFile("services-test-all.json");
        }
        else {
            # If we will get user's specific services
            if ($param3 != null && $param3 != "" && $param4 != null && $param4 != "") {
                echo getFile("services-test-specific.json");
            }
            else {              # If not, we should get param2 as service-id
                echo getFile("service-" . $param2 . ".json");
            }
        }
    }
    else if ($param1 == "frivilligavtale") {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            # Get JSON as a string
            $json_str = file_get_contents('php://input');

            # Get as an array
            $json_obj = json_decode($json_str, true);

            $file = "voluntary-appointments-".$json_obj["bruker_id"]."-".$json_obj["avtale_id"].".json";
            $json = json_decode(getFile($file), true);
            $json["endret_varighet"] = $json_obj["endret_varighet"];
            $json["endret_merknad"] = $json_obj["endret_merknad"];
            file_put_contents($file, json_encode($json));
        }
        else {
            $files = glob('voluntary-appointments-*-'.$param2.'.json');
            // Get agreements if exist:
            for ($i = 0; $i < sizeof($files); $i++) {
                echo getFile($files[$i]);
            }
        }
    }
    else if ($param1 == "aktiviteter") {
        echo getFile("activities.json");
    }
    else if ($param1 == "meldinteresse") {
        # For this url-endpoint we only do things for GET
        echo json_encode(createCollection([]));
    }
    else {
        err();
    }
}

function user($param1, $param2) {
    if ($param1 == "login") {
        $json = null;
        # Get JSON as a string
        $json_str = file_get_contents('php://input');

        # Get as an array
        $json_obj = json_decode($json_str, true);

        if ($json_obj["bruker_id"] == "NTNU" && $json_obj["bruker_passord"] == "123") {
            $json["userId"] = 9999;
        }
        else if ($json_obj["bruker_id"] == "Test1" && $json_obj["bruker_passord"] == "123") {
            $json["userId"] = 7600;
        }
        else if ($json_obj["bruker_id"] == "Test2" && $json_obj["bruker_passord"] == "123") {
            $json["userId"] = 7601;
        }
        else if ($json_obj["bruker_id"] == "Test3" && $json_obj["bruker_passord"] == "123") {
            $json["userId"] = 7620;
        }
        echo json_encode($json);
    }
    else if ($param1 == "frivillig") {
        $result = array();
        $result["frv_id"] = $param2;
        echo json_encode(createCollection($result));
    }
    
}

function update($param1, $userId) {
    $file = "userInfo-" . $userId . ".json";
    if ($param1 == "hent") {
        echo getFile($file);
    }
    else if ($param1 == "navn") {
        # Get JSON as a string
        $json_str = file_get_contents('php://input');
        # Get as an array
        $json_obj = json_decode($json_str, true);
        # Edit JSON
        $json = json_decode(getFile($file), true);
        $json["bru_fornavn"] = htmlspecialchars($json_obj["fornavn"]);
        $json["bru_etternavn"] = htmlspecialchars($json_obj["etternavn"]);
        file_put_contents($file, json_encode($json));
    }
    else if ($param1 == "epost") {
        # Get JSON as a string
        $json_str = file_get_contents('php://input');
        # Get as an array
        $json_obj = json_decode($json_str, true);
        # Edit JSON
        $json = json_decode(getFile($file), true);
        $json["bru_epost"] = htmlspecialchars($json_obj["epost"]);
        file_put_contents($file, json_encode($json));
    }
    else if ($param1 == "mobil") {
        # Get JSON as a string
        $json_str = file_get_contents('php://input');
        # Get as an array
        $json_obj = json_decode($json_str, true);
        # Edit JSON
        $json = json_decode(getFile($file), true);
        $json["bru_mobiltelefon"] = htmlspecialchars($json_obj["mobil"]);
        file_put_contents($file, json_encode($json));
    }
    else if ($param1 == "tel") {
        # Get JSON as a string
        $json_str = file_get_contents('php://input');
        # Get as an array
        $json_obj = json_decode($json_str, true);
        # Edit JSON
        $json = json_decode(getFile($file), true);
        $json["bru_telefonnr"] = htmlspecialchars($json_obj["tel"]);
        file_put_contents($file, json_encode($json));
    }
    else {
        err();
    }
}

function unavailable($param1, $param2) {
    if ($param1 == "fast") {
        $files = glob('unavailable-fixed-'.$param2.'-*');
        $result = array();

        // List all agreements for that user in array:
        for ($i = 0; $i < sizeof($files); $i++) {
            array_push($result, json_decode(getFile($files[$i]), true));
        }

        echo json_encode(createCollection($result));
    }
    else if ($param1 == "ferie") {
        $files = glob('unavailable-holiday-'.$param2.'-*');
        $result = array();

        // List all agreements for that user in array:
        for ($i = 0; $i < sizeof($files); $i++) {
            array_push($result, json_decode(getFile($files[$i]), true));
        }

        echo json_encode(createCollection($result));
    }
    else if ($param1 == "redigerFast") {
        $files = glob('unavailable-fixed-*-'.$param2.'.json');     // Get "all" whith id of value to $param2.
        if (sizeof($files) > 0) {
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                # Get JSON as a string
                $json_str = file_get_contents('php://input');
                # Get as an array
                $json_obj = json_decode($json_str, true);
                # Edit JSON
                $json = json_decode(getFile($files[0]), true);
                $json["tgh_dag"] = htmlspecialchars($json_obj["tgh_dag"]);
                $json["tgh_kl_fra"] = htmlspecialchars($json_obj["tgh_kl_fra"]);
                $json["tgh_kl_til"] = htmlspecialchars($json_obj["tgh_kl_til"]);
                $json["tgh_merknad"] = htmlspecialchars($json_obj["tgh_merknad"]);
                file_put_contents($file, json_encode($json)); 
                success("Opprettet tid");       
            }
            else if ($_SERVER['REQUEST_METHOD'] === 'DELETE') {
                if (file_exists($files[0]))
                {
                $deleted= unlink($files[0]);

                    if ($deleted)
                    {
                        success("Tiden er nå tilgjengelig");
                    }
                    else
                    {
                        echo '{"success": false, message": "Klarte ikke å fullføre forespørselen"}';
                    }
                }
                else
                {
                    echo '{"success": false, message": "Den eksisterer ikke"}';
                }
            }
            else {
                err();
            }
        } 
        else {
            err();
        }
    }
    else if ($param1 == "redigerFerie") {
        $files = glob('unavailable-holiday-*-'.$param2.'.json');     // Get "all" whith id of value to $param2.
        if (sizeof($files) > 0) {
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                # Get JSON as a string
                $json_str = file_get_contents('php://input');
                # Get as an array
                $json_obj = json_decode($json_str, true);
                # Edit JSON
                $json = json_decode(getFile($files[0]), true);
                $json["fer_fra_dato"] = htmlspecialchars($json_obj["fer_dato_fra"]);
                $json["fer_til_dato"] = htmlspecialchars($json_obj["fer_dato_til"]);
                $json["fer_kommentar"] = htmlspecialchars($json_obj["fer_kommentar"]);
                file_put_contents($file, json_encode($json)); 
                success("Opprettet tid");       
            }
            else if ($_SERVER['REQUEST_METHOD'] === 'DELETE') {
                if (file_exists($files[0]))
                {
                $deleted= unlink($files[0]);

                    if ($deleted)
                    {
                        success("Tiden er nå tilgjengelig");
                    }
                    else
                    {
                        echo '{"success": false, message": "Klarte ikke å fullføre forespørselen"}';
                    }
                }
                else
                {
                    echo '{"success": false, message": "Den eksisterer ikke"}';
                }
            }
            else {
                err();
            }
        } 
        else {
            err();
        }
    }
    else if ($param1 == "nyFast") {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            # Get JSON as a string
            $json_str = file_get_contents('php://input');
            # Get as an array
            $json_obj = json_decode($json_str, true);
            # Get id
            $id = intval(getFile("last-unavailable-fixed-id.txt"));
            $id++;
            file_put_contents("last-unavailable-fixed-id.txt", $id);
            # Make JSON
            $json = array();
            $json["tgh_id"] = $id;
            $json["tgh_frv_id"] = $param2;                  // We use userId as frvId in mock-api.
            $json["tgh_dag"] = htmlspecialchars($json_obj["tgh_dag"]);
            $json["tgh_kl_fra"] = htmlspecialchars($json_obj["tgh_kl_fra"]);
            $json["tgh_kl_til"] = htmlspecialchars($json_obj["tgh_kl_til"]);
            $json["tgh_merknad"] = htmlspecialchars($json_obj["tgh_merknad"]);
            
            # The dates are fixed in our mock-api
            $json["opprettet_dato"] = htmlspecialchars("2019-02-21T14:16:29Z");
            $json["opprettet_av"] = htmlspecialchars("NTNU");
            $json["endret_dato"] = htmlspecialchars("2019-03-14T14:18:56Z");
            $json["endret_av"] = htmlspecialchars("NTNU");

            file_put_contents($file, json_encode($json)); 
            success("Opprettet tid");       
        }
        else {
            err();
        }
    }
    else if ($param1 == "nyFerie") {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            # Get JSON as a string
            $json_str = file_get_contents('php://input');
            # Get as an array
            $json_obj = json_decode($json_str, true);
            # Get id
            $id = intval(getFile("last-unavailable-holiday-id.txt"));
            $id++;
            file_put_contents("last-unavailable-holiday-id.txt", $id);
            # Make JSON
            $json = array();
            $json["fer_id"] = $id;
            $json["fer_frv_id"] = $param2;                  // We use userId as frvId in mock-api.
            $json["fer_fra_dato"] = htmlspecialchars($json_obj["fer_dato_fra"]);
            $json["fer_til_dato"] = htmlspecialchars($json_obj["tgh_dato_til"]);
            $json["fer_kommentar"] = htmlspecialchars($json_obj["fer_kommentar"]);

            file_put_contents($file, json_encode($json)); 
            success("Opprettet ferie");       
        }
        else {
            err();
        }
    }
    else {
        err();
    }
}

function err() {
    echo '{"success": false, "message": "Not a valid api-endpoint"}';
}
function success($message) {
    echo '{"success": true, "message": "'.$message.'"}';
}

function createCollection($result) {
    $jsonStructure["items"] = $result;
    $jsonStructure["hasMore"] = false;
    return $jsonStructure;
}

function getFile($file) {
    if (file_exists($file)) {
        return file_get_contents($file);
    }
    else {
        err();
    }
}

function getInterest($id) {
    // Interests:
    $entry1["id"] = 15;
    $entry1["navn"] = "Dra på tur";
    $entry1["beskrivelse"] = "Man går på tur i villmarken";
    $entry1["status"] = "Aktiv";
    $entry1["kategori"] = "Aktivitet";

    $entry2["id"] = 16;
    $entry2["navn"] = "Bingo";
    $entry2["beskrivelse"] = "Bingokveld";
    $entry2["status"] = "Aktiv";
    $entry2["kategori"] = "Arrangement";
            
    $entry3["id"] = 17;
    $entry3["navn"] = "Natteravn";
    $entry3["beskrivelse"] = "Delta som natteravn";
    $entry3["status"] = "Aktiv";
    $entry3["kategori"] = "Aktivitet";

    $entry4["id"] = 18;
    $entry4["navn"] = "Avlastning";
    $entry4["beskrivelse"] = "Avlastning av en person";
    $entry4["status"] = "Aktiv";
    $entry4["kategori"] = "Aktivitet";

    // If -1, get all:
    if ($id == -1) {
        $results = array();
        array_push($results, $entry1, $entry2, $entry3, $entry4);
        return $results;
    }
    else {
        if ($entry1["id"] == $id) {
            return $entry1;
        }
        else if ($entry2["id"] == $id) {
            return $entry2;
        }
        else if ($entry3["id"] == $id) {
            return $entry3;
        }
        else if ($entry4["id"] == $id) {
            return $entry4;
        }
    }
}

//echo "module: " . $module;

switch ($module) {
    case "frivillig":
        voluntary($param1, $param2, $param3);
        break;
    case "tjenester":
        services($param1, $param2, $param3, $param4, $param5);
        break;
    case "bruker":
        user($param1, $param2);
        break;
    case "oppdater":
        update($param1, $param2);
        break;
    case "utilgjengelighet":
        unavailable($param1, $param2);
        break;
    default:
        err();
}

?>